using AngleSharp.Html.Parser;
using Hncore.Infrastructure.Common;
using Hncore.Infrastructure.Extension;
using Hncore.Infrastructure.Serializer;
using Hncore.Infrastructure.WebApi;
using Hncore.Pass.Vpn.Model;
using Hncore.Pass.Vpn.Request.Product;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using System;
using System.Text;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.IO;
using System.Threading.Tasks;
namespace Hncore.Pass.Vpn.Service
{
    public class AgentClient18Service:AgentClientBaseService
    {
        string LoginUrl { get; set; } = "api/login";
        string LoginCodeUrl { get; set; } = "main/imgcode.html";
        string RefrushTokenUrl { get; set; } = "agent/index.html";
        string SingleAddUrl { get; set; } = "api/number";
        string SingleReAddUrl { get; set; } = "api/number/renew";
        string MuiltAddUrl { get; set; } = "agent/memberMuiltAdd.html";
        string RefundUrl { get; set; } = "api/number/refund";      
        string UpdateUrl = "api/number/";//agent/memberUpdate/id/1155709.html 
        string OnlineUrl { get; set; } = "api/numberLine/";
        string KIllUrl { get; set; } = "api/numberOffline";
        string searchAccountUrl = "api/numberSingle/";
        string searchTestAccountUrl = "api/numberSingle/";
        string DeleteUrl { get; set; } = "api/number/refund";//1160862.html";
        IHttpClientFactory m_HttpClientFactory;       
        public AgentClient18Service(IHttpClientFactory httpClientFactory):base(httpClientFactory)
        {
            m_HttpClientFactory = httpClientFactory;
        }     

        public override async Task<int> RefrushStatus()
        {
            return 1;
        }
        public override async Task<(byte[], string)> GetCode()
        {          
            var client = CreateHttpClient(false);
            if (this.LoginUrl.NotHas()) return (null, "");
            var getResp = await client.GetAsync(this.LoginUrl);
            var cookie = this.GetCookie(getResp, "PHPSESSID");
            if (cookie.Has())
            {
                client.DefaultRequestHeaders.Add("Cookie", cookie);
                var ret = await client.GetByteArrayAsync(this.LoginCodeUrl + "?t=" + DateTime.Now.Millisecond);
                return (ret, cookie);
            }
            return (null, "");
        }
        public override async Task<ApiResult> Login(AgentLoginRequest request)
        {      
            return new ApiResult(request.Key);
        }
        public override bool CheckAccount(int productId,List<string> accounts)
        {
            return false;
        }

         public override async Task<ApiResult> NewAccount(string packageKey, string account, string pwd, int connCount = 1, int accountType = 1, int payCount = 1)
        {

            var url = "?secretId=108006113&secretKey=87085a351a64c116df09ebc07d5781sf&type=adduser&user="+account+"&pass="+pwd+"&serverid="+packageKey+"&logincount="+connCount.ToString()+"&idname=万勇强&idcard=410325199407079912";

            if (packageKey == "test") {
                url = "?secretId=108006113&secretKey=87085a351a64c116df09ebc07d5781sf&type=addtestuser&user="+account+"&password="+pwd+"&idname=万勇强&idcard=410325199407079912";
            }

            var client = CreateHttpClient();

            var resp = await client.GetAsync(url);
            var content = "";
            using (var sr = new StreamReader(resp.Content.ReadAsStreamAsync().Result, Encoding.GetEncoding("iso-8859-1")))
            {
                content = sr.ReadToEnd();
            }
            JObject jo = (JObject)JsonConvert.DeserializeObject(content);
            var status = jo["code"].ToString();
            
            if (status =="1")
            {
                return new ApiResult(ResultCode.C_SUCCESS);
            }
            else
            {
                return new ApiResult(ResultCode.C_INVALID_ERROR, "开户失败");
            }
        }

        /// <summary>
        /// 新开
        /// </summary>
        /// <param name="packageId"></param>
        /// <param name="account"></param>
        /// <param name="pwd"></param>
        /// <returns></returns>
        public override async Task<ApiResult> NewMuiltAccount(string packageKey, string account, string pwd, int connCount = 1, int accountType = 1,int startNum=0, int endNum=1 )
        {
            var client = CreateHttpClient();
            var map = new Dictionary<string, string>(){
                {"group","single" },
                {"number",account },
                {"password",pwd },
                {"connect",connCount.ToString()},
                {"interval","1"},
                {"type",packageKey},
                {"body","api"},
                {"mobile","13073735878"}
            };
            var title = GetOpTitle("NewAccount", account);
            LogHelper.Info(title, map.ToJson());
            try
            {
                var resp = await client.PostAsForm(this.SingleAddUrl, map);
                var content = await resp.Content.ReadAsStringAsync();
                JObject jo = (JObject)JsonConvert.DeserializeObject(content);
                var status = jo["status"].ToString();
                if (status =="400")
                {
                    return new ApiResult(ResultCode.C_SUCCESS);
                }
                else
                {
                    LogHelper.Error(title, content);
                    return new ApiResult(ResultCode.C_INVALID_ERROR, "开户失败");
                }
            }
            catch (Exception ex)
            {
                LogHelper.Error(title, ex.Message);
                return new ApiResult(ResultCode.C_INVALID_ERROR, "开户失败");
            }
        }

        /// <summary>
        /// 续费
        /// </summary>
        /// <param name="productId"></param>
        /// <param name="account"></param>
        /// <param name="pwd"></param>
        /// <returns></returns>
        public override async Task<ApiResult> NewReAccount(string packageKey, string account, int connCount, int payCount = 1)
        {

            var url = "?secretId=108006113&secretKey=87085a351a64c116df09ebc07d5781sf&type=buy&user="+account+"&serverid="+packageKey;

            var client = CreateHttpClient();

            var resp = await client.GetAsync(url);
            var content = "";
            using (var sr = new StreamReader(resp.Content.ReadAsStreamAsync().Result, Encoding.GetEncoding("iso-8859-1")))
            {
                content = sr.ReadToEnd();
            }
            JObject jo = (JObject)JsonConvert.DeserializeObject(content);
            var status = jo["code"].ToString();

            if (status =="1")
            {
                return new ApiResult(1);
            }
            else
            {
                return new ApiResult(ResultCode.C_INVALID_ERROR, "续费失败");
            }
        }
        /// <summary>
        /// 删除账号
        /// </summary>
        /// <param name="productId"></param>
        /// <param name="account"></param>
        /// <returns></returns>
        public override async Task<bool> DeleteAccount(string account)
        {

            Random rd = new Random(Guid.NewGuid().GetHashCode());
            int i = rd.Next();

            var time_s = DateTime.Now.GetUnixTimeStamp();
            var agentid = "admin1";
            var nonce =  MD5(time_s.ToString()) + i.ToString();
            var apikey = "a478ad5aa3079bbbef3cd45e2d55d61e";
            var sign = MD5(time_s+nonce+apikey);



            var url = "/api/raduserRefund?agentid="+agentid+"&ti="+time_s+"&nonce="+nonce+"&sign="+sign+"&username="+account;

            var client = CreateHttpClient();

            var resp = await client.GetAsync(url);
            var content = await resp.Content.ReadAsStringAsync();
            Console.WriteLine("==============================================================");
            Console.WriteLine(content);
            Console.WriteLine("==============================================================");
            JObject jo = (JObject)JsonConvert.DeserializeObject(content);
            var status = jo["errcode"].ToString();
            
            if (status =="0")
            {
                return true;
            }
            else
            {
                return false;
            }

        }
        /// <summary>
        /// 得到账号信息
        /// </summary>
        /// <param name="productId"></param>
        /// <param name="account"></param>
        /// <returns></returns>
        public override async Task<ApiResult<OriginAccountModel>> GetAccountInfo(string account,bool isTest=false)
        {

            var url = "?secretId=108006113&secretKey=87085a351a64c116df09ebc07d5781sf&type=getuserinfo&user="+account;

            var client = CreateHttpClient();

            var resp = await client.GetAsync(url);
            var content = "";
            using (var sr = new StreamReader(resp.Content.ReadAsStreamAsync().Result, Encoding.GetEncoding("iso-8859-1")))
            {
                content = sr.ReadToEnd();
            }
            JObject jo = (JObject)JsonConvert.DeserializeObject(content);
            var status = jo["code"].ToString();

            if (status =="1")
            {
                var trData = new OriginAccountModel
                {
                    Id = "",
                    Account = account,
                    Pwd = jo["password"].ToString(),
                    AccountType = jo["pause"].ToString(),
                    Package = "",
                    ConnectCount = jo["logincount"].ToString(),
                    RegistTime = "",
                    EndTime = jo["expiretime"].ToString(),
                    RestTime = "",
                    Amount = "",
                    Remark = "",
                };
                return new ApiResult<OriginAccountModel>(trData);
            }
            else
            {
                return new ApiResult<OriginAccountModel>(ResultCode.C_INVALID_ERROR, "没有查询到信息");
            }



        }
        /// <summary>
        /// 修改账号密码
        /// </summary>
        /// <param name="productId"></param>
        /// <param name="account"></param>
        /// <param name="pwd"></param>
        /// <returns></returns>
        public override async Task<bool> UpdateAccountPwd(string account, string pwd)
        {

            var url = "?secretId=108006113&secretKey=87085a351a64c116df09ebc07d5781sf&type=setuser&user="+account+"&new_pwd="+pwd;

            var client = CreateHttpClient();

            var resp = await client.GetAsync(url);
            var content = "";
            using (var sr = new StreamReader(resp.Content.ReadAsStreamAsync().Result, Encoding.GetEncoding("iso-8859-1")))
            {
                content = sr.ReadToEnd();
            }
            JObject jo = (JObject)JsonConvert.DeserializeObject(content);
            var status = jo["code"].ToString();
            if (status =="1")
            {
                return true;
            }
            else
            {
                return false;
            }

        }
        /// <summary>
        /// 退款
        /// </summary>
        /// <param name="packageId"></param>
        /// <param name="account"></param>
        /// <returns></returns>
        public override async Task<ApiResult> Refund(string account, string packageKey, int days)
        {

           
            return new ApiResult(ResultCode.C_INVALID_ERROR, "退款失败");

        }
        /// <summary>
        /// 是否在线
        /// </summary>
        /// <param name="productId"></param>
        /// <param name="account"></param>
        /// <returns></returns>
        public override async Task<ApiResult<List<OriginAccountOnlineModel>>> OnLine(string account)
        {

            var url = "?secretId=108006113&secretKey=87085a351a64c116df09ebc07d5781sf&type=get_user_onlinelog&user="+account;

            var client = CreateHttpClient();

            var resp = await client.GetAsync(url);
            var content = "";
            using (var sr = new StreamReader(resp.Content.ReadAsStreamAsync().Result, Encoding.GetEncoding("iso-8859-1")))
            {
                content = sr.ReadToEnd();
            }
            JObject jo = (JObject)JsonConvert.DeserializeObject(content);
            var status = jo["code"].ToString();

            var retData = new List<OriginAccountOnlineModel>();
            if (status =="1")
            {
                if(jo.ContainsKey("data")){
                    foreach (var tr in jo["data"])
                    {
                        JObject jsondata = (JObject)JsonConvert.DeserializeObject(tr.ToJson());

                        var trData = new OriginAccountOnlineModel
                        {
                            Account = account,
                            ServerIP = jsondata["server_ip"].ToString(),
                            LoginTime = "",
                            OnlineTime = jsondata["online_time"].ToString(),
                            LoginIP = jsondata["client_ip"].ToString(),
                            UpStream = "",
                            DownStream = "",
                            Id=  "{user:\""+account+"\",address:\""+jsondata["address"].ToString()+"\",server_ip:\""+jsondata["server_ip"].ToString()+"\"}",
                        
                        };
                        
                        retData.Add(trData);
                    }
                }
                return new ApiResult<List<OriginAccountOnlineModel>>(retData);
            }
            else
            {
                return new ApiResult<List<OriginAccountOnlineModel>>(retData);
            }

        }
        /// <summary>
        /// 踢号
        /// </summary>
        /// <param name="productId"></param>
        /// <param name="account"></param>
        /// <returns></returns>
        public override async Task<bool> KillOut( string id)
        {

            JObject info = (JObject)JsonConvert.DeserializeObject(id);

            var url = "?secretId=108006113&secretKey=87085a351a64c116df09ebc07d5781sf&type=user_online_offline&user="+info["user"].ToString()+"&address="+info["address"].ToString()+"&server_ip="+info["server_ip"].ToString();

            var client = CreateHttpClient();

            var resp = await client.GetAsync(url);
            var content = "";
            using (var sr = new StreamReader(resp.Content.ReadAsStreamAsync().Result, Encoding.GetEncoding("iso-8859-1")))
            {
                content = sr.ReadToEnd();
            }
            JObject jo = (JObject)JsonConvert.DeserializeObject(content);
            var status = jo["code"].ToString();


            if (status =="1")
            {
                return true;
            }  
            return false;    
        }

        /// <summary>
        /// 是否存在
        /// </summary>      
        /// <param name="account"></param>
        /// <returns></returns>
        public override async Task<bool> Exist(string account)
        {
            var url = "?secretId=108006113&secretKey=87085a351a64c116df09ebc07d5781sf&type=getuserlenNum&user="+account;


            var client = CreateHttpClient();

            var resp = await client.GetAsync(url);

            var content = "";
            using (var sr = new StreamReader(resp.Content.ReadAsStreamAsync().Result, Encoding.GetEncoding("iso-8859-1")))
            {
                content = sr.ReadToEnd();
            }
            
            JObject jo = (JObject)JsonConvert.DeserializeObject(content);
            var status = jo["status"].ToString();
            
            if (status =="success")
            {
                return false;
            }
            return true;
        }
    }
}
